"""
unit tests for module modutils
squeleton generated by py2tests on May 23 at 10:05:11

 Copyright (c) 2002-2003 LOGILAB S.A. (Paris, FRANCE).
 http://www.logilab.fr/ -- mailto:contact@logilab.fr

module manipulation utilities

"""
__revision__ = "$Id: unittest_modutils.py,v 1.2 2003/05/28 15:14:20 syt Exp $"

import unittest
import sys
from logilab.common import modutils
    
class load_module_from_name_FunctionTest(unittest.TestCase):
    
    def knownValues_load_module_from_name_1(self):
        """ load a python module from it's name """
        self.assertEqual(modutils.load_module_from_name('unittest'), unittest)

    
class get_module_part_FunctionTest(unittest.TestCase):
    
    def knownValues_get_module_part_1(self):
        """ load a python module from it's name """
        self.assertEqual(modutils.get_module_part('logilab.common.modutils'),
                         'logilab.common.modutils')

    def knownValues_get_module_part_2(self):
        """ load a python module from it's name """
        self.assertEqual(modutils.get_module_part('logilab.common.modutils.get_module_part'),
                         'logilab.common.modutils')

    
class modpath_from_file_FunctionTest(unittest.TestCase):
    
    def knownValues_modpath_from_file_1(self):
        """ given an absolute file path return the python module's path as a list """
        self.assertEqual(modutils.modpath_from_file(modutils.__file__),
                         ['logilab', 'common', 'modutils'])
    
    def raise_modpath_from_file_Exception(self):
        self.assertRaises(Exception, modutils.modpath_from_file, '/turlututu')

    
class is_standard_module_FunctionTest(unittest.TestCase):
    
    def knownValues_is_standard_module_1(self):
        """
        return true if the module may be considered as a module from the standard
        library
        """
        self.assertEqual(modutils.is_standard_module('sys'), 1)
        
    def knownValues_is_standard_module_2(self):
        """
        return true if the module may be considered as a module from the standard
        library
        """
        self.assertEqual(modutils.is_standard_module('logilab'), 0)

    
class is_relative_FunctionTest(unittest.TestCase):
    
    def knownValues_is_relative_1(self):
        """
        return true if the module may be considered as a module from the standard
        library
        """
        from logilab import common
        self.assertEqual(modutils.is_relative('modutils', common.__path__[0]), 1)

    def knownValues_is_relative_2(self):
        """
        return true if the module may be considered as a module from the standard
        library
        """
        from logilab.common import tree
        self.assertEqual(modutils.is_relative('modutils', tree.__file__), 1)
        
    def knownValues_is_relative_3(self):
        """
        return true if the module may be considered as a module from the standard
        library
        """
        from logilab import common
        self.assertEqual(modutils.is_relative('logilab.common.modutils',
                                              common.__path__[0]), 0)
    
class get_modules_FunctionTest(unittest.TestCase):
    
    def knownValues_get_modules_1(self): #  XXXFIXME: TOWRITE
        """ given a directory return a list of all available python modules, even
        in subdirectories

        """
        self.assertEqual(modutils.get_modules(package, src_directory, blacklist=('CVS',)), None)


    
def Run():
    testsuite = unittest.TestSuite()
    testsuite.addTest(load_module_from_name_FunctionTest("knownValues_load_module_from_name_1"))
    testsuite.addTest(get_module_part_FunctionTest("knownValues_get_module_part_1"))
    testsuite.addTest(get_module_part_FunctionTest("knownValues_get_module_part_2"))
    testsuite.addTest(modpath_from_file_FunctionTest("knownValues_modpath_from_file_1"))
    testsuite.addTest(modpath_from_file_FunctionTest("raise_modpath_from_file_Exception"))
    testsuite.addTest(is_standard_module_FunctionTest("knownValues_is_standard_module_1"))
    testsuite.addTest(is_standard_module_FunctionTest("knownValues_is_standard_module_2"))
    testsuite.addTest(is_relative_FunctionTest("knownValues_is_relative_1"))
    testsuite.addTest(is_relative_FunctionTest("knownValues_is_relative_2"))
    testsuite.addTest(is_relative_FunctionTest("knownValues_is_relative_3"))
    #testsuite.addTest(get_modules_FunctionTest("knownValues_get_modules_1"))
    test = unittest.TextTestRunner()
    # uncomment next line to write tests results in a file
    #test.__init__(open('tests.log','w+'))    
    return test.run(testsuite)
    
if __name__ == '__main__':
    Run()
